//  ** Revision History **
//  14-Oct-1992 (AH) ColorBar added
//  22-Aug-1992 (AH) DrawButton moved to Eurotool.c
//  03-Jul-1992 (AH) About Box added
//  22-Jun-1992 (AH) Flyttat till PWB

//****************************************************************************
//                    Copyright (C) 1992-1995 EuroSource AB
//
// FILE:        Counter.c (Part of EuroTool project)        
//   
// PURPOSE:     Counter Button
//   
// COMMENTS:    Original from Microsoft CDK package (THANK YOU!)
//   
// HISTORY:     920608AH  - From CDK Package
//   
//****************************************************************************

#define  NOCOMM
#include <windows.h>
#include <vbapi.h>
#include "escntr.h" 

#include "version.h"
#define  CTL_DATA           // To declare static data in cntr.h
#include "counter.h"
#include "vb1.h"		// Support for Visual Basic 1.0
#include "vb2.h"		// Support for Visual Basic 2.0
#include "helpid.h"

//---------------------------------------------------------------------------
// Global Variables
//---------------------------------------------------------------------------
extern HANDLE hmodDLL;
extern WORD ipropDialog;
extern HCTL hctlDialog; 
extern USHORT VBVersion;
HANDLE	ghWndCntr;		 // handle for hWnd of Control

//---------------------------------------------------------------------------
// Local Prototypes
//---------------------------------------------------------------------------
VOID NEAR DeleteBitMaps(PCNTR pcntr);
VOID NEAR PaintCntr(PCNTR pcntr, HWND hWnd, HDC hdc);
ERR  NEAR ErrSetCntrVal(PCNTR pcntr, HWND hWnd, float Val);
VOID NEAR SizeCntr(PCNTR pcntr, HWND hWnd);

//---------------------------------------------------------------------------
// Cntr Control Procudure
//---------------------------------------------------------------------------
LONG FAR PASCAL _export CntrCtlProc(HCTL hctl, HWND hWnd, USHORT msg, USHORT wp, LONG lp)
{
    PCNTR  pcntr;

    segCntr = (_segment)hctl;
    pcntr = CNTRDEREF(hctl);

    // Message pre-processing
    switch (msg)
    {
    case WM_NCCREATE:
	pcntr->hFont = NULL;
	ErrSetCntrVal(pcntr, hWnd, (float)0.0);
	pcntr->DigitsLeft = 3;
	pcntr->DigitsRight = 0;
	pcntr->colorBackRight = COLOR_HIGHLIGHT | 0x80000000;
	pcntr->colorForeRight = COLOR_HIGHLIGHTTEXT | 0x80000000;
	pcntr->Buttons = FALSE;
	pcntr->Look3D = FALSE;
	pcntr->Font3D =  FONT3DNORMAL;
	pcntr->Separators = TRUE;                   
	pcntr->IncSelected = FALSE;
	pcntr->DecSelected = FALSE;
	pcntr->ChangeValue = 1;

#ifndef RUNTIMEVERSION
	// set the property text for the About dialog
	SetAboutText(hctl, IPROP_CNTR_ABOUT);
#endif

	VBSetControlProperty(hctl, IPROP_CNTR_BACKCOLOR, 
				       CNTR_BACKGROUND_DEFAULT);
	break;

#ifndef RUNTIMEVERSION  
	case VBM_HELP:
	    switch (LOBYTE(wp))
		{
			case VBHELP_PROP:
		    	// High byte identifies which property.
		    	// Keyword is: "<property>"
		    	switch (HIBYTE(wp))
				{
					case IPROP_CNTR_ABOUT:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_about);
			    		return OK;

					case IPROP_CNTR_CHANGEVALUE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_changevalue);
			    		return 0L;                                                        
                
            		case IPROP_CNTR_BACKCOLORRIGHT:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_backcolorright);
			    		return 0L;                                            
            
            		case IPROP_CNTR_BUTTONS:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_buttons);
			    		return 0L;                                            
            
            		case IPROP_CNTR_FONT3D:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_font3d);
			    		return 0L;                                       
            
            		case IPROP_CNTR_HWND:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_hwnd);
			    		return 0L;                                      
            
            		case IPROP_CNTR_DIGITSLEFT:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_digitsleft);
			    		return 0L;                                             
            
                	case IPROP_CNTR_DIGITSRIGHT:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_digitsright);
			    		return 0L;                                            
                     
                	case IPROP_CNTR_FORECOLORRIGHT:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_forecolorright);
			    		return 0L;                                      
                                                                             
                	case IPROP_CNTR_SEPARATORS:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_separators);
			    		return 0L;
                    
                	case IPROP_CNTR_LOOK3D:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_look3d);
			    		return 0L; 
                    
                    case IPROP_CNTR_VALUE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_value);
			    		return 0L; 
				}
				break;

		case VBHELP_CTL:
		    // High byte is unused.
		    // Keyword is: "<classname>"
		    WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, escounter);
		    return 0L;
	}
	break;        



    case VBM_INITPROPPOPUP:
	switch (wp) {
	    case IPROP_CNTR_ABOUT:
		hctlDialog  = hctl;
		ipropDialog = wp;
		return (LONG)HwndInitAboutPopup();
	
	case IPROP_CNTR_BACKCOLORRIGHT:
	case IPROP_CNTR_FORECOLORRIGHT:
	    if (VBVersion < 0x0200) {
		hctlDialog  = hctl;
		ipropDialog = wp;
		return (LONG)HwndInitColorPopup();
		}
	}
	break;

#endif

    case WM_GETMINMAXINFO:
	((LPPOINT)lp)[3].x = 4;
	((LPPOINT)lp)[3].y = 4;
	return 1L;

    case WM_SIZE:
	SizeCntr(pcntr, hWnd);
	break;

    case WM_SETFONT:
	pcntr->hFont = (HFONT)wp;
	DeleteBitMaps(pcntr);
	break;

    case WM_GETFONT:
	return pcntr->hFont;
   
    case WM_TIMER:
	break;
   
    case WM_MOUSEMOVE: {
	POINT   pt;   
    
	if (pcntr->Buttons && (pcntr->IncSelected || 
						pcntr->DecSelected)) { 
	    pt.x = LOWORD(lp);
		pt.y = HIWORD(lp);                         
		if (!PtInRect(&pcntr->rectButtons, pt)) {
		ReleaseCapture();
		pcntr->IncSelected = FALSE;
		pcntr->DecSelected = FALSE;
		SizeCntr(pcntr, hWnd);        
		InvalidateRect(hWnd, NULL, FALSE);
		DeleteBitMaps(pcntr);
	    }                                       
	}               
	}             
	break;

    case WM_RBUTTONDBLCLK: 
	    if (VBGetMode() == MODE_DESIGN) {
		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, escounter);
		return OK;
	    }
	    else
		break;
			
    case WM_LBUTTONDBLCLK:
    case WM_LBUTTONDOWN: {      
	POINT   pt;
	float   Value;
    
	pt.x = LOWORD(lp);
	pt.y = HIWORD(lp);
	// only react if buttons
	if (pcntr->Buttons) {
		if (PtInRect(&pcntr->rectButtonInc, pt)) {
		SetCapture(hWnd);
		pcntr->IncSelected = TRUE;                
		Value = pcntr->Value+pcntr->ChangeValue;
		ErrSetCntrVal(pcntr, hWnd, Value);
		SizeCntr(pcntr, hWnd);        
		InvalidateRect(hWnd, NULL, FALSE);
		DeleteBitMaps(pcntr);
	    }
		if (PtInRect(&pcntr->rectButtonDec, pt)) {
		SetCapture(hWnd);
		pcntr->DecSelected = TRUE;  
		Value = pcntr->Value-pcntr->ChangeValue;              
		if (ErrSetCntrVal(pcntr, hWnd, Value) != ERR_None)
		    ErrSetCntrVal(pcntr, hWnd, 0);
		SizeCntr(pcntr, hWnd);        
		InvalidateRect(hWnd, NULL, FALSE);
		DeleteBitMaps(pcntr);
	    }  
	}                 
	}
	break;
    
    
    case WM_LBUTTONUP:          
	{ 
	POINT   pt;
    
	pt.x = LOWORD(lp);
	pt.y = HIWORD(lp);    
	// only react if buttons
	if (pcntr->Buttons) {
		if (PtInRect(&pcntr->rectButtons, pt)) {
		ReleaseCapture();
		pcntr->IncSelected = FALSE; 
		pcntr->DecSelected = FALSE;               
		SizeCntr(pcntr, hWnd);        
		InvalidateRect(hWnd, NULL, FALSE);
		DeleteBitMaps(pcntr);
	    }      
	}
	}
	break;
	
    case WM_ERASEBKGND:
	return TRUE;

    case WM_PAINT:
	if (wp)
		PaintCntr(pcntr, hWnd, (HDC)wp);
	else
	{
		PAINTSTRUCT ps;

		BeginPaint(hWnd, &ps);
		PaintCntr(pcntr, hWnd, ps.hdc);
		EndPaint(hWnd, &ps);
	}
	break;

    case VBM_SETPROPERTY:
	switch (wp)
	{
	case IPROP_CNTR_DIGITSLEFT:
	    if ((SHORT)lp < 1 || (SHORT)lp > 6)
		return ERR_InvPropVal;
	    pcntr->DigitsLeft = (SHORT)lp;
	    SizeCntr(pcntr, hWnd);
	    InvalidateRect(hWnd, NULL, FALSE);
	    return ERR_None;

	case IPROP_CNTR_DIGITSRIGHT:
	    if ((SHORT)lp < 0 || (SHORT)lp > 5)
		return ERR_InvPropVal;
	    pcntr->DigitsRight = (SHORT)lp;
	    SizeCntr(pcntr, hWnd);
	    InvalidateRect(hWnd, NULL, FALSE);
	    return ERR_None;

	case IPROP_CNTR_VALUE:
	    return ErrSetCntrVal(pcntr, hWnd, (*(float FAR *)&(lp)));

	case IPROP_CNTR_BACKCOLORRIGHT:
	case IPROP_CNTR_FORECOLORRIGHT:
	case IPROP_CNTR_BACKCOLOR:
	case IPROP_CNTR_FORECOLOR:
	case IPROP_CNTR_BUTTONS:
	case IPROP_CNTR_LOOK3D:
	case IPROP_CNTR_FONT3D:            
	case IPROP_CNTR_SEPARATORS:    
	    SizeCntr(pcntr, hWnd);        
	    InvalidateRect(hWnd, NULL, FALSE);
	    DeleteBitMaps(pcntr);
	    return ERR_None;
	}
	break;

    case VBM_GETPROPERTY:
    {
	if (wp == IPROP_CNTR_HWND)
	{
		ghWndCntr = VBGetControlHwnd(hctl);
		(HWND *)lp = &ghWndCntr;
		return OK;
	}
	break;
    }

}



    // Default processing:
    return VBDefControlProc(hctl, hWnd, msg, wp, lp);
}

//****************************************************************************
//                                      Copyright (C) 1992-1995 EuroSource AB
//
// FUNCTION:    VOID NEAR DeleteBitMaps(PCNTR pcntr)    
//
// PURPOSE:         Delete currently cached bitmaps.  Called when control size, 
//                              font, or color has changed.  Bitmaps will be recalculated 
//                              next time they are needed.
//
// COMMENTS:
//
// HISTORY:     15-Aug-1992-1995 Sat 15:29:06 AH  PREHISTORY
//
//****************************************************************************

VOID NEAR DeleteBitMaps(PCNTR pcntr)
{
    if (pcntr->hbmp[0])
    {
	DeleteObject(pcntr->hbmp[0]);
	pcntr->hbmp[0] = NULL;
    }   

    if (pcntr->hbmp[1])
    {
	DeleteObject(pcntr->hbmp[1]);
	pcntr->hbmp[1] = NULL;
    }
}

//****************************************************************************
//                                      Copyright (C) 1992-1995 EuroSource AB
//
// FUNCTION:    HBITMAP NEAR GetBitMap(PCNTR pcntr, HWND hWnd, SHORT inx)       
//
// PURPOSE:             Caluculate new bitmaps.  We will create and paint a new 
//                              bitmap which looks like:
//      -+
//      0|
//      -+
//      1|
//      -+
//      2|
//      -+
//      :
//      -+
//      9|
//      -+
//      0|
//      -+
// using the correct colors and font.   
//
// COMMENTS:
//
// HISTORY:     15-Aug-1992-1995 Sat 15:27:26 AH  PREHISTORY
//
//****************************************************************************

HBITMAP NEAR GetBitMap(PCNTR pcntr, HWND hWnd, SHORT inx)
{
    static  CHAR szDig[] = "01234567890";
    RECT    rcClient;
    RECT    rcDigit;
    SHORT   digit;
    SHORT   DigitHeight;
    HDC     hdcScr;
    HDC     hdcMem;
    HBITMAP hbmp;
    HBITMAP hbmpOld;
    HBRUSH  hbr;
    HFONT   hfontOld = NULL;
    HPEN        hPenOld, hPenLight;
    char        digit3D[2]; // fix for 3D-font draw
    
    
    if (pcntr->hbmp[inx])
	return pcntr->hbmp[inx];
    
    GetClientRect(hWnd, &rcClient);
    
    // create light pen
    hPenLight = CreatePen(PS_SOLID,1, WHITE);
    
    DigitHeight = rcClient.bottom + 1;
    rcDigit = rcClient;
    rcDigit.right = rcClient.right = pcntr->DigitWidth - 
									((pcntr->Separators) ?  1 : 0) ;
    rcClient.bottom = DigitHeight * 11;
    hdcScr = GetDC(NULL);
    hdcMem = CreateCompatibleDC(hdcScr);
    hbmp = CreateCompatibleBitmap(hdcScr, rcClient.right+1, rcClient.bottom+1);
    ReleaseDC(NULL, hdcScr);
    if (!hbmp)
    {
	DeleteDC(hdcMem);
	return NULL;
    }
    pcntr->hbmp[inx] = hbmp;
    hbmpOld = SelectObject(hdcMem, hbmp);
    // set up colors, etc.
    if (!inx)
	hbr = (HBRUSH)SendMessage(GetParent(hWnd), WM_CTLCOLOR, hdcMem, MAKELONG(hWnd, 0));
    else
    {
	LONG BackColor = RGBCOLOR(pcntr->colorBackRight);
	LONG ForeColor = RGBCOLOR(pcntr->colorForeRight);

	hbr = CreateSolidBrush(BackColor);
	SetTextColor(hdcMem, ForeColor);
    }
    if (hbr)
    {
	FillRect(hdcMem, &rcClient, hbr);
	if (inx)
		DeleteObject(hbr); 
    }
    SetBkMode(hdcMem, TRANSPARENT);
    if (pcntr->hFont)
	hfontOld = SelectObject(hdcMem, pcntr->hFont);
    if (pcntr->Separators) {
	MoveTo(hdcMem, rcClient.right, 0);
	LineTo(hdcMem, rcClient.right, rcClient.bottom);
	if (pcntr->Look3D) {
		hPenOld = SelectObject(hdcMem, hPenLight);
		MoveTo(hdcMem, rcClient.right-1, 0);
		LineTo(hdcMem, rcClient.right-1, rcClient.bottom); 
		SelectObject(hdcMem, hPenOld);
	}
    }    
    for (digit = 0; digit <= 10; ++digit)
    {   
	if (pcntr->Separators) {
		MoveTo(hdcMem, 0, rcDigit.bottom);
		LineTo(hdcMem, rcDigit.right, rcDigit.bottom); 
		if (pcntr->Look3D) {
			hPenOld = SelectObject(hdcMem, hPenLight);
			MoveTo(hdcMem, rcClient.right-1, 0);
			LineTo(hdcMem, rcClient.right-1, rcClient.bottom); 
			SelectObject(hdcMem, hPenOld);
		}
	}    
		//DrawText(hdcMem, &szDig[digit], 1, &rcDigit,
		//      DT_CENTER | DT_VCENTER | DT_SINGLELINE | DT_NOCLIP);
	digit3D[0] = szDig[digit];
	digit3D[1] = 0;
	DrawFont3D(hdcMem, digit3D, &rcDigit,
		(DT_CENTER | DT_VCENTER | DT_SINGLELINE | DT_NOCLIP), 
		pcntr->Font3D, 
		TRANSPARENT,GetTextColor(hdcMem));
	rcDigit.top += DigitHeight;
	rcDigit.bottom += DigitHeight;
    } 
    
	
    if (hfontOld)
	SelectObject(hdcMem, hfontOld);
    SelectObject(hdcMem, hbmpOld);
    DeleteObject(hPenLight);
    DeleteDC(hdcMem);
    return pcntr->hbmp[inx];
}

//****************************************************************************
//                                              Copyright (C) 1992-1995 EuroSource AB
//
// FUNCTION:    VOID NEAR SizeCntr(PCNTR pcntr, HWND hWnd)      
//
// PURPOSE:         Handle the resizing.  Calculate new width for digits and the 
//                              size of the gap.  Delete the old bitmaps, so that new ones 
//                              will be created on the next paint.
//
// COMMENTS:
//
// HISTORY:     15-Aug-1992-1995 Sat 15:24:07 AH  PREHISTORY
//
//****************************************************************************

VOID NEAR SizeCntr(PCNTR pcntr, HWND hWnd)
{
    RECT    rcClient;
    SHORT   digits;
    int         height;

    GetClientRect(hWnd, &rcClient); 

    if (pcntr->Buttons) { 
	// set buttons rectangle
	pcntr->rectButtons.left = rcClient.right-(rcClient.right/5);
	pcntr->rectButtons.top = rcClient.top;
	pcntr->rectButtons.right = rcClient.right;
	pcntr->rectButtons.bottom = rcClient.bottom;
	height = (pcntr->rectButtons.bottom-pcntr->rectButtons.top)/2;                               
	CopyRect(&pcntr->rectButtonInc, &pcntr->rectButtons);
	pcntr->rectButtonInc.bottom = height;
	CopyRect(&pcntr->rectButtonDec, &pcntr->rectButtons);
	pcntr->rectButtonDec.top = height;
	// if buttons indent right margin
	rcClient.right = pcntr->rectButtons.left-1;
    }
	   
    digits = pcntr->DigitsLeft + pcntr->DigitsRight;
    pcntr->DigitWidth = (rcClient.right + 1) / digits;
    pcntr->Gap = rcClient.right + 1 - digits * pcntr->DigitWidth;
    DeleteBitMaps(pcntr);
}

//****************************************************************************
//                                      Copyright (C) 1992-1995 EuroSource AB
//
// FUNCTION:    ERR NEAR ErrSetCntrVal(PCNTR pcntr, HWND hWnd, float Val)       
//
// PURPOSE:         Handle setting a new value.
//
// COMMENTS:
//
// HISTORY:     15-Aug-1992-1995 Sat 15:25:52 AH  PREHISTORY
//
//****************************************************************************

ERR NEAR ErrSetCntrVal(PCNTR pcntr, HWND hWnd, float Val)
{
    LONG    ValInt;
    LONG    ValFrac;
    SHORT   digit;
    SHORT   last;
    SHORT   StartRoll;
    CHAR    szVal[13];

    if (Val < (float)0.0)
	return ERR_InvPropVal;
    if (Val > (float)999999.0)
	return ERR_InvPropVal;
    pcntr->Value = Val;
    ValInt = (LONG)Val;
    ValFrac = (LONG)((Val - (float)ValInt) * 1000000.0);
    wsprintf(szVal, "%06ld%06ld", ValInt, ValFrac);
    last = 6 + pcntr->DigitsRight;
    StartRoll = last - 1;
    for (digit = last; digit >= 6 - pcntr->DigitsLeft; --digit)
	if (digit == StartRoll - 1 && szVal[StartRoll] == '9')
		--StartRoll;
    pcntr->StartRoll = StartRoll;
    pcntr->RollVal = (szVal[last] - '0') * 10;
    if (last < 11)
	pcntr->RollVal += (szVal[last+1] - '0');
    lstrcpy(pcntr->szVal, szVal);
    InvalidateRect(hWnd, NULL, FALSE);
    return ERR_None;
}

//****************************************************************************
//                                              Copyright (C) 1992-1995 EuroSource AB
//
// FUNCTION:    VOID NEAR PaintCntr(PCNTR pcntr, HWND hWnd, HDC hdc)    
//
// PURPOSE:         Handle painting.  Blit the correct portion of the stashed 
//                              bitmaps for each digit.
//
// COMMENTS:
//
// HISTORY:     14-Aug-1992-1995 Fri 15:31:26 AH  PREHISTORY
//
//****************************************************************************

VOID NEAR PaintCntr(PCNTR pcntr, HWND hWnd, HDC hdc)
{
    RECT    rcDigit;
    SHORT   digit;
    HBRUSH  hbr;
    SHORT   roll;
    SHORT   top;
    HDC     hdcMem;
    HBITMAP hbmp;
    HBITMAP hbmpOld = NULL;
    RECT        Brect;          // single button rect
    UINT        height;         // height of buttons area 

    hdcMem = CreateCompatibleDC(hdc);
    if (!hdcMem)
    return;

    // size the situation
    GetClientRect(hWnd, &rcDigit);
    hbr = (HBRUSH)SendMessage(GetParent(hWnd), WM_CTLCOLOR, hdc, MAKELONG(hWnd, 0));
    rcDigit.right = pcntr->Gap;
    FillRect(hdc, &rcDigit, hbr);
    rcDigit.left  = rcDigit.right;
    rcDigit.right = rcDigit.left + pcntr->DigitWidth;

    roll = (pcntr->RollVal * rcDigit.bottom) / 100;
    for (digit = 6 - pcntr->DigitsLeft; digit <= 5 + pcntr->DigitsRight; ++digit)
    {
	hbmp = GetBitMap(pcntr, hWnd, digit >= 6);
	if (!hbmp) 
	{
		if (hbmpOld)
			SelectObject(hdcMem, hbmpOld);
		DeleteDC(hdcMem);
		return;
	}
	hbmpOld = SelectObject(hdcMem, hbmp);
	if (RectVisible(hdc, &rcDigit))
	{
		top = (pcntr->szVal[digit] - '0') * (rcDigit.bottom + 1);
		if (digit >= pcntr->StartRoll)
		top += roll;
		BitBlt(hdc, rcDigit.left, rcDigit.top, pcntr->DigitWidth, rcDigit.bottom + 1,
		hdcMem, 0, top, SRCCOPY);
	}
	rcDigit.left  = rcDigit.right;
	rcDigit.right = rcDigit.left + pcntr->DigitWidth;
    }               

    if (hbmpOld)
	SelectObject(hdcMem, hbmpOld);
    DeleteDC(hdcMem);
       
    // here we handle 3D-look and buttons
    //if users want buttons give him that
	if (pcntr->Buttons) {         
	// fill in background
	FillRect(hdc, &pcntr->rectButtons, hbr);
	height = (pcntr->rectButtons.bottom-pcntr->rectButtons.top)/2;
	// draw increase button
	CopyRect(&Brect, &pcntr->rectButtons);    
	Brect.bottom = height;
	if (pcntr->IncSelected)
		DrawButton(hdc, &Brect, DARKGREY, WHITE);
	else
	    DrawButton(hdc, &Brect, WHITE, DARKGREY);
	// draw decrease button
	CopyRect(&Brect, &pcntr->rectButtons);    
	Brect.top = height;
	if (pcntr->DecSelected)
		DrawButton(hdc, &Brect, DARKGREY, WHITE);
	else
	    DrawButton(hdc, &Brect, WHITE, DARKGREY);
    }  
  
    //if users want 3D-look give him that
	if (pcntr->Look3D) { 
	//GetClientRect(hWnd, &rcDigit);
	//DrawButton(hdc, &rcDigit, WHITE, DARKGREY);
    } 
	
}
