//****************************************************************************
//                    Copyright (C) 1992 EuroSource AB
//
// FILE:        Counter.h        
//   
// PURPOSE:     Counter button
//   
// COMMENTS:     
//   
// HISTORY:     920608AH
//   
//****************************************************************************                    

#ifndef RC_INVOKED 

//Default Background Color
#define CNTR_BACKGROUND_DEFAULT 0x00C0C0C0

//---------------------------------------------------------------------------
// Cntr control data and structs
//---------------------------------------------------------------------------
_segment segCntr;

#define BP _based(segCntr) *    // based pointer

#define BH BP BP                // based handle

typedef VOID BH BHVOID;         // void handle

typedef CHAR BH BHSTR;          // handle to a string

typedef struct tagCNTR
{   
    HSZ		hszabout;
    HFONT   hFont;
    float   Value;      
    float	ChangeValue;	// amount to change when clicked
    CHAR    szVal[13];
    SHORT   DigitsLeft;
    SHORT   DigitsRight;
    LONG    colorBackRight;
    LONG    colorForeRight;
    SHORT   DigitWidth;
    SHORT   StartRoll;
    SHORT   RollVal;
    SHORT   Gap;
    HBITMAP hbmp[2];
    RECT	rectButtons;	// rectangle for buttons 
    RECT	rectButtonInc;
    RECT	rectButtonDec;
	BOOL	Buttons;		// TRUE if buttons
	BOOL	Look3D;			// TRUE if 3D look
	ENUM	Font3D;			// Text drawing type
	BOOL	Separators;		// TRUE if separators
	BOOL	IncSelected;	// TRUE if increase button selected
	BOOL	DecSelected;	// TRUE if decrease button selected
} CNTR;

typedef CNTR BP PCNTR;

#define CNTRDEREF(hctl)     ((PCNTR)(VOID *)(SHORT)(LONG)VBDerefControl(hctl))


//---------------------------------------------------------------------------
// Control Procudure
//---------------------------------------------------------------------------
LONG FAR PASCAL _export CntrCtlProc(HCTL, HWND, USHORT, USHORT, LONG);


//---------------------------------------------------------------------------
// Property info
//---------------------------------------------------------------------------

#ifdef CTL_DATA

PROPINFO Property_Counter_About =
{
    "About...",
    DT_HSZ | PF_fGetData | PF_fSetData | PF_fEditable,
    OFFSETIN(CNTR, hszabout)
};                              

PROPINFO propinfoCntrBackColorRight =
{
    "BackColorRight",
    DT_COLOR | PF_fGetData | PF_fSetData | PF_fSetMsg | PF_fSaveData | PF_fEditable,
    OFFSETIN(CNTR,colorBackRight), 0
};

PROPINFO propinfoCntrDigitsLeft =
{
    "DigitsLeft",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSaveData,
    OFFSETIN(CNTR,DigitsLeft), 0
};

PROPINFO propinfoCntrDigitsRight =
{
    "DigitsRight",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSaveData,
    OFFSETIN(CNTR,DigitsRight), 0
};

PROPINFO propinfoCntrForeColorRight =
{
    "ForeColorRight",
    DT_COLOR | PF_fGetData | PF_fSetData | PF_fSetMsg | PF_fSaveData | PF_fEditable,
    OFFSETIN(CNTR,colorForeRight), 0
};

PROPINFO propinfoCntrValue =
{
    "Value",
    DT_REAL | PF_fGetData | PF_fSetMsg | PF_fSaveData,
    OFFSETIN(CNTR,Value), 0
};

PROPINFO propinfoCntrChangeValue =
{
    "ChangeValue",
    DT_REAL | PF_fGetData | PF_fSetData | PF_fSaveData,
    OFFSETIN(CNTR,ChangeValue), 0
};


PROPINFO propinfoCntrButtons =
{
    "Buttons",
    DT_BOOL | PF_fGetData | PF_fSetData | PF_fSetMsg | PF_fSaveData,
    OFFSETIN(CNTR,Buttons), 0
};
                         
PROPINFO propinfoCntrLook3D =
{
    "Look3D",
    DT_BOOL | PF_fGetData | PF_fSetData | PF_fSetMsg | PF_fSaveData,
    OFFSETIN(CNTR,Look3D), 0
};

PROPINFO propinfoCntrFont3D =
{
    "Font3D",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData,
    OFFSETIN(CNTR,Font3D), 0,
    0,
    "0 - Normal Text.\0"
    "1 - Carved light.\0"
    "2 - Carved Heavy.\0"
    "3 - Raised light.\0"
    "4 - Raised Heavy.\0",
    FONT3DRAISEDHEAVY
};

PROPINFO propinfoCntrSeparators =
{
    "Separators",
    DT_BOOL | PF_fGetData | PF_fSetData | PF_fSetMsg | PF_fSaveData,
    OFFSETIN(CNTR,Separators), 0
};

PROPINFO propinfoCntrhWnd =
{
    "hWnd",
    DT_SHORT | PF_fGetMsg | PF_fNoShow | PF_fNoRuntimeW,
    0, 0
};
#endif  // CTL_DATA


//---------------------------------------------------------------------------
// Property list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the properties
//---------------------------------------------------------------------------
#define IPROP_CNTR_CTLNAME      0x0000
#define IPROP_CNTR_INDEX        0x0001
#define IPROP_CNTR_BACKCOLOR    0x0002
#define IPROP_CNTR_FORECOLOR    0x0003
#define IPROP_CNTR_LEFT         0x0004
#define IPROP_CNTR_TOP          0x0005
#define IPROP_CNTR_WIDTH        0x0006
#define IPROP_CNTR_HEIGHT       0x0007
#define IPROP_CNTR_VISIBLE      0x0008
#define IPROP_CNTR_FONTNAME     0x0009
#define IPROP_CNTR_FONTSIZE     0x000A
#define IPROP_CNTR_FONTBOLD     0x000B
#define IPROP_CNTR_FONTITALIC   0x000C
#define IPROP_CNTR_FONTSTRIKE   0x000D
#define IPROP_CNTR_FONTUNDER    0x000E
#define IPROP_CNTR_PARENT       0x000F
#define IPROP_CNTR_DRAGMODE     0x0010
#define IPROP_CNTR_DRAGICON     0x0011
#define IPROP_CNTR_TAG          0x0012
#define IPROP_CNTR_VALUE        0x0013
#define IPROP_CNTR_DIGITSLEFT   0x0014
#define IPROP_CNTR_DIGITSRIGHT  0x0015
#define IPROP_CNTR_BACKCOLORRIGHT 0x0016
#define IPROP_CNTR_FORECOLORRIGHT 0x0017
#define IPROP_CNTR_ABOUT		0x0018
#define IPROP_CNTR_BUTTONS		0x0019
#define IPROP_CNTR_LOOK3D		0x001A
#define IPROP_CNTR_FONT3D		0x001B
#define IPROP_CNTR_SEPARATORS	0x001C
#define IPROP_CNTR_CHANGEVALUE	0x001D
#define IPROP_CNTR_BORDERSTYLE	0x001E
#define IPROP_CNTR_HWND 		0x001F

#ifdef CTL_DATA
PPROPINFO proplistCntr[] =
{
    PPROPINFO_STD_CTLNAME,
    PPROPINFO_STD_INDEX,
    PPROPINFO_STD_BACKCOLOR,
    PPROPINFO_STD_FORECOLOR,
    PPROPINFO_STD_LEFT,
    PPROPINFO_STD_TOP,
    PPROPINFO_STD_WIDTH,
    PPROPINFO_STD_HEIGHT,
    PPROPINFO_STD_VISIBLE,
    PPROPINFO_STD_FONTNAME,
    PPROPINFO_STD_FONTSIZE,
    PPROPINFO_STD_FONTBOLD,
    PPROPINFO_STD_FONTITALIC,
    PPROPINFO_STD_FONTSTRIKE,
    PPROPINFO_STD_FONTUNDER,
    PPROPINFO_STD_PARENT,
    PPROPINFO_STD_DRAGMODE,
    PPROPINFO_STD_DRAGICON,
    PPROPINFO_STD_TAG,
    &propinfoCntrValue,
    &propinfoCntrDigitsLeft,
    &propinfoCntrDigitsRight,
    &propinfoCntrBackColorRight,
    &propinfoCntrForeColorRight,    
    &Property_Counter_About,
    &propinfoCntrButtons,
    &propinfoCntrLook3D,
    &propinfoCntrFont3D,
    &propinfoCntrSeparators,
    &propinfoCntrChangeValue,
    PPROPINFO_STD_BORDERSTYLEON,
    &propinfoCntrhWnd,
    NULL
};
#endif  // CTL_DATA


//---------------------------------------------------------------------------
// Event list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the events
//---------------------------------------------------------------------------
#define EVENT_CNTR_DRAGDROP     0
#define EVENT_CNTR_DRAGOVER     1

#ifdef CTL_DATA
PEVENTINFO eventlistCntr[] =
{
    PEVENTINFO_STD_DRAGDROP,
    PEVENTINFO_STD_DRAGOVER,
    NULL
};
#endif  // CTL_DATA


//---------------------------------------------------------------------------
// Model struct
//---------------------------------------------------------------------------
// Define the control model (using the event and property structures).
//---------------------------------------------------------------------------
#ifdef CTL_DATA
MODEL modelCntr =
{
    VB_VERSION,                         // VB version being used
    MODEL_fDesInteract | MODEL_fFocusOk, // MODEL flags
    (PCTLPROC)CntrCtlProc,              // Control procedure
    CS_VREDRAW | CS_HREDRAW,            // Class style
    WS_BORDER,		                    // Default Window style
    sizeof(CNTR),                       // Size of CNTR structure
    IDBMP_CNTR,                         // Palette bitmap ID
    "EsCounter",			 			// Default control name
    "EsCounter",			 			// Visual Basic class name
    NULL,                               // Parent class name
    proplistCntr,                       // Properties list
    eventlistCntr,                      // Events list 
    IPROP_CNTR_VALUE,					// Default property
	EVENT_CNTR_DRAGDROP,				// Default event
	IPROP_CNTR_VALUE,					// Standard property  
};
#endif  // CTL_DATA

LPMODEL modellistCntr[] =
    {
    &modelCntr,
    NULL
    };

MODELINFO modelinfoCntr =
    {
    VB_VERSION, 			// VB version being used
    modellistCntr			// MODEL list
    };

#endif  // RC_INVOKED

//---------------------------------------------------------------------------
